﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.8
@EndOfDesignText@
private Sub Class_Globals
	Public Recycler As Amir_RecyclerView
	Public TitleBar As Panel
	Private mParent As Panel
	Private Data As List
	Private RVTop As Int = 48dip
	Public Loaded As Boolean
	Private HasAds As Boolean
	Private ViewType As String
'     Private LastSnap As Int = 0
	Dim TitleLbl As Label
	
	Public TYPE_VIDEO_BANNER As String="VideoBanner"
	Public TYPE_BANNER As String="Banner"
	Public TYPE_DEFAULT As String="Default"
End Sub

Public Sub Initialize (Parent As Panel)
	mParent=Parent
	
	Recycler.Initializer("RV").ListView.Horizontal.Build
	mParent.AddView(Recycler,0,48dip,mParent.Width,158dip)
	Recycler.ItemOffsetsListener(True)
	Recycler.LinearSnapHelper2(Gravity.LEFT,False)
	
	MakeParentStyle(Parent)
End Sub

Public Sub OnBind(Parent As Panel,Title As String,SubTitle As String,TypeViews As String,ContentData As List)
	ViewType=TypeViews
	mParent=Parent
	MakeParentStyle(Parent)
	If TitleBar.IsInitialized Then _
	TitleBar.RemoveAllViews
	Data=ContentData
	MakeTitleBar(Title,SubTitle)
	MakeRecyclerView
End Sub

Private Sub GetRecyclerHeight As Int
	Select ViewType
		Case TYPE_DEFAULT
			Return 158dip
		Case TYPE_VIDEO_BANNER
			Return 248dip
		Case TYPE_BANNER
			Return 182dip
	End Select
	Return 0
End Sub

Private Sub MakeParentStyle ( Parent As Panel )
	Dim Color As GradientDrawable
	Color.Initialize("TOP_BOTTOM",Array As Int(Colors.White,Colors.White))
	Color.CornerRadius=2dip
	Parent.Background=Color
	Parent.Elevation=2dip
	Dim P As Phone
	If P.SdkVersion >= 21 Then
		Dim jo As JavaObject = Parent
		jo.RunMethod("setClipToOutline",Array(True))
	End If
End Sub

Private Sub  NewMoreLabel As Label
	Dim More As Label
	More.Initialize("")
	More.TextColor=0xff0F9D58
	More.TextSize=12
	More.Text="MORE"
	More.Typeface=Typeface.DEFAULT_BOLD
	More.Gravity=Bit.Or(Gravity.CENTER_VERTICAL,Gravity.RIGHT)
	Return More
End Sub


Private Sub TitleBar_Click
End Sub
Private Sub MakeTitleBar (Title As String , SubTitle As String)
	Dim Utils As Amir_RVUtils
	TitleBar.Initialize("TitleBar")
	Dim HasSubTitle As Boolean = True
	If SubTitle.Length=0 Then HasSubTitle=False

	TitleLbl.Initialize("")
	TitleLbl.TextColor=Colors.DarkGray
	TitleLbl.TextSize=14
	TitleLbl.Gravity=Gravity.LEFT
	Dim More As Label = NewMoreLabel
	Select HasSubTitle
		Case True
			mParent.AddView(TitleBar,0,0,mParent.width,64dip)
			RVTop=64dip
			TitleBar.AddView(TitleLbl,16dip,14dip,150dip,20dip)
			Dim SubTitleLbl As Label
			SubTitleLbl.Initialize("")
			SubTitleLbl.TextColor=Colors.Gray
			SubTitleLbl.TextSize=12
			SubTitleLbl.Gravity=Gravity.LEFT
			SubTitleLbl.Text=SubTitle
			TitleBar.AddView(SubTitleLbl,16dip,TitleLbl.Top+TitleLbl.Height,150dip,16dip)
			SubTitleLbl.Width=Utils.GetTextWidth(SubTitleLbl)
			TitleBar.AddView(More,TitleBar.Left+TitleBar.Width-100dip,24dip,86dip,16dip)
		Case False
		     HasAds = Title.StartsWith("[ads]")
			mParent.AddView(TitleBar,0,0,mParent.width,48dip)
			RVTop=48dip
			Select HasAds
				Case True
					Title=Title.Replace("[ads]","")
					Dim AdsLabel As Label
					AdsLabel.Initialize("")
					TitleBar.AddView(AdsLabel,16dip,16dip,26dip,16dip)
					AdsLabel.Text="Ads"
					AdsLabel.TextColor=0xff0F9D58
					AdsLabel.TextSize=10
					AdsLabel.Gravity=Gravity.CENTER
					Dim Color As ColorDrawable
					Color.Initialize2(Colors.Transparent,2dip,2dip,0xff0F9D58)
					AdsLabel.Background=Color
					TitleBar.AddView(TitleLbl,AdsLabel.Left+AdsLabel.Width+8dip,14dip,150dip,20dip)
				Case False
					TitleBar.AddView(TitleLbl,16dip,14dip,150dip,20dip)
			End Select
			TitleBar.AddView(More,TitleBar.Left+TitleBar.Width-100dip,16dip,86dip,16dip)
	End Select
	TitleLbl.Text=Title
	TitleLbl.Width=Utils.GetTextWidth(TitleLbl)
	'Utils.RippleToView(TitleBar).Color(Colors.LightGray).Alpha(0.4f).Build
	Dim Ripple As AppCompat
	Ripple.SetClickEffect(TitleBar,False)
	Sleep(0)
End Sub




Private Sub MakeRecyclerView
	If Recycler=Null Or Recycler.IsInitialized=False Then
		For Each Rv As Amir_RecyclerView In mParent.GetAllViewsRecursive
			Recycler=Rv
			Exit
		Next
	End If
	Try
	Dim Height As Int = GetRecyclerHeight
	Recycler.Height=Height
	mParent.Height=RVTop+Height+10dip
	Recycler.Top=RVTop
	
If Recycler.Adapter=Null Then
	Dim Adapter As Amir_RVAdapter
	Adapter.Initialize("RV",Adapter.LOOP_NEVER)
	Recycler.Adapter=Adapter
	Else
		Recycler.Adapter2.NotifyDataSetChanged
	End If	
		Sleep(0)
	Catch
		Try
			Recycler.RemoveView
		Catch
			Log("")
		End Try
			
		Recycler.Initializer("RV").ListView.Horizontal.Build
		mParent.AddView(Recycler,0,48dip,mParent.Width,158dip)
		Recycler.ItemOffsetsListener(True)
		Recycler.LinearSnapHelper2(Gravity.LEFT,False)
		Dim Height As Int = GetRecyclerHeight
		Recycler.Height=Height
		mParent.Height=RVTop+Height+10dip
		Recycler.Top=RVTop
		Dim Adapter As Amir_RVAdapter
		Adapter.Initialize("RV",Adapter.LOOP_NEVER)
		Recycler.Adapter=Adapter
		
	End Try
End Sub

private Sub RV_GetItemOffsets (OutRect As Rect,Item As Object,Position As Int)
'If Position=0 Or  Position=LastSnap Then 
If Position=0 Then
		OutRect.Left=6dip
		Else
		OutRect.Left=6dip
	End If
	If Position = Recycler.Adapter2.ItemCount-1 Then
		OutRect.Right=12dip
	End If
End Sub

private Sub RV_GetItemCount As Int
	Return Data.Size
End Sub

private Sub RV_onCreateViewHolder (Parent As Panel,mViewType As Int)
	Select mViewType
	Case 0
		CreateDefaultViews(Parent)
	Case 1
		CreateVideoBannerViews(Parent)
	Case 2
		CreateBannerViews(Parent)
	End Select
End Sub
private Sub RV_onBindViewHolder (Parent As Panel,Position As Int)
	Dim mViewType As Int = Recycler.Utils.GetViewHolder.ItemViewType
	Select mViewType
		Case 0
			BindDefaultViews(Parent,Position)
		Case 1
			BindVideoBannerViews(Parent,Position)
		Case 2
			BindBannerViews(Parent,Position)
	End Select
End Sub
Private Sub RV_GetItemViewType (Position As Int) As Int
	Select ViewType
		Case TYPE_DEFAULT
			Return 0
		Case TYPE_VIDEO_BANNER
			Return 1
		Case TYPE_BANNER
			Return 2
	End Select
	Return -1
End Sub

Private Sub LoadImage (Img As ImageView , Link As String)
	Dim Glide As Amir_Glide
	Glide.Initializer.Default
	Dim Defualt As ColorDrawable
	Defualt.Initialize(Colors.RGB(238,238,238),0)
	Glide.Load(Link).Apply(Glide.RO.ErrorDrawable(Defualt).Placeholder(Defualt).CenterCrop).Into(Img)
End Sub


private Sub SetEllipsize(TextView As Label)
	Dim jo As JavaObject=TextView
	jo.RunMethod("setLines",Array(2))
	jo.RunMethod("setEllipsize",Array("END"))
End Sub



Private Sub CreateDefaultViews(Parent As Panel)
	Dim Img As ImageView
	Img.Initialize("")
	Parent.AddView(Img,6dip,0,100dip,100dip)
	Img.Padding=Array As Int(2dip,2dip,2dip,2dip)
	
	Dim Title As Label
	Title.Initialize("")
	Parent.AddView(Title,6dip,106dip,84dip,34dip)
	Title.TextColor=Colors.Black
	Title.TextSize=12
	Title.Gravity=Bit.Or(Gravity.LEFT,Gravity.TOP)
	
	Dim Size As Label
	Size.Initialize("")
	Parent.AddView(Size,6dip,Title.Top+Title.Height+2dip,Title.Width,14dip)
	Size.TextColor=Colors.Gray
	Size.TextSize=12
	Size.SingleLine=True
	Size.Ellipsize="END"
	Size.Gravity=Gravity.LEFT
	
	Dim Ripple As Label
	Ripple.Initialize("Ripple")
	Parent.AddView(Ripple,6dip,0,112dip,158dip)
	Dim P As Phone
	If P.SdkVersion<21 Then
		Recycler.Utils.RippleToView(Ripple).Color(0xFF8F8F8F).Alpha(0.3f).Build
	Else
		Dim Ac As AppCompat
		Ac.SetClickEffect(Ripple,False)
	End If
	
	Dim MenuLbl As Label
	MenuLbl.Initialize("")
	Parent.AddView(MenuLbl,100dip,104dip,12dip,20dip)
	MenuLbl.TextColor=Colors.DarkGray
	MenuLbl.Text=Chr(0xE5D4)
	MenuLbl.TextSize=16
	MenuLbl.Typeface=Typeface.LoadFromAssets("MaterialIcons.ttf")
	
	Dim MenuClick As Label
	MenuClick.Initialize("MenuClick")
	Parent.AddView(MenuClick,80dip,94dip,36dip,40dip)
	Dim Menu As ACPopupMenu
	Menu.Initialize("Menu",MenuClick)
	MenuClick.Tag=Menu
	MenuLbl.Tag=Menu
	MenuLbl.Gravity=Bit.Or(Gravity.RIGHT,Gravity.TOP)
End Sub
Private Sub BindDefaultViews (Parent As Panel,Position As Int)
	Dim DataMap As Map = Data.Get(Position)
	LoadImage(Parent.GetView(0),DataMap.Get("Image"))
	Dim Title=Parent.GetView(1),Size=Parent.GetView(2) As Label
	Title.Text=DataMap.Get("Title")
	SetEllipsize(Title)
	Size.Text=DataMap.Get("Size")
	Parent.Height=158dip
	If Position+1 = Data.Size Then
		Parent.Width=118dip
	Else
		Parent.Width=106dip
	End If
	
	Dim MenuLbl As Label = Parent.GetView(4)
	Dim Menu As ACPopupMenu = MenuLbl.Tag
	Menu.GetMenu.Clear
	Menu.AddMenuItem(1&0&Position,"Install",Null)
	Menu.AddMenuItem(2&0&Position,"Add to wishlist",Null)
	If HasAds Then Menu.AddMenuItem(3&0&Position,"Why this ad?",Null)
End Sub



Private Sub Ripple_Click
End Sub

Private Sub MenuClick_Click
	Dim Label As Label = Sender
	Dim Menu As ACPopupMenu=Label.Tag
	Menu.Show
End Sub
Private Sub Menu_ItemClicked (Item As ACMenuItem)
	Dim All As String = Item.Id
	Dim Position As Int = All.SubString2(2,All.Length)
	Dim ItemClicked As Int = All.SubString2(0,1)
	
	Dim DataMap As Map = Data.Get(Position)
	Dim Title As String=DataMap.Get("Title")
	Select ItemClicked
		Case 1
			ToastMessageShow("Install "&Title,False)
		Case 2
			ToastMessageShow("Add "&Title&" to wishlist",False)
		Case 3
			ToastMessageShow("Why "&Title&" ad?",False)
	End Select
End Sub



Private Sub CreateVideoBannerViews(Parent As Panel)
	Dim Banner As ImageView
	Banner.Initialize("Banner")
	Parent.AddView(Banner,6dip,0,334dip,186dip)
	
	Dim Img As ImageView
	Img.Initialize("")
	Parent.AddView(Img,6dip,Banner.Height+16dip,40dip,40dip)
	
	Dim Title As Label
	Title.Initialize("")
	Parent.AddView(Title,Img.Left+Img.Width+16dip,Img.Top,240dip,20dip)
	Title.TextColor=Colors.Black
	Title.TextSize=12
	Title.Gravity=Bit.Or(Gravity.LEFT,Gravity.CENTER_VERTICAL)
	
	Dim Size As Label
	Size.Initialize("")
	Parent.AddView(Size,Img.Left+Img.Width+16dip,228dip,50dip,16dip)
	Size.TextColor=Colors.Gray
	Size.TextSize=12
	Size.SingleLine=True
	Size.Ellipsize="END"
	Size.Gravity=Gravity.LEFT
	
	Dim Ripple As Label
	Ripple.Initialize("Ripple")
	Parent.AddView(Ripple,0,0,350dip,248dip)
	Dim Ac As AppCompat
	Ac.SetClickEffect(Ripple,False)
	
	Dim BannerClick As Label
	BannerClick.Initialize("Banner")
	Parent.AddView(BannerClick,6dip,0,334dip,186dip)
	
	Dim MenuLbl As Label
	MenuLbl.Initialize("")
	Parent.AddView(MenuLbl,334dip,200dip,12dip,20dip)
	MenuLbl.TextColor=Colors.DarkGray
	MenuLbl.Text=Chr(0xE5D4)
	MenuLbl.TextSize=16
	MenuLbl.Typeface=Typeface.LoadFromAssets("MaterialIcons.ttf")
	
	Dim MenuClick As Label
	MenuClick.Initialize("MenuClick")
	Parent.AddView(MenuClick,314dip,190dip,36dip,40dip)
	Dim Menu As ACPopupMenu
	Menu.Initialize("Menu",MenuClick)
	MenuClick.Tag=Menu
	MenuLbl.Tag=Menu
	MenuLbl.Gravity=Bit.Or(Gravity.RIGHT,Gravity.TOP)
	
	Dim Play As Label
	Play.Initialize("")
	Parent.AddView(Play,148dip,69dip,48dip,48dip)
	Play.TextColor=Colors.White
	Play.Text=Chr(0xE037)
	Play.TextSize=30
	Play.Gravity=Gravity.CENTER
	Play.Typeface=Typeface.LoadFromAssets("MaterialIcons.ttf")
	Dim Color As ColorDrawable
	Color.Initialize(Colors.ARGB(150,0,0,0),1000dip)
	Play.Background=Color
End Sub

Private Sub BindVideoBannerViews (Parent As Panel,Position As Int)
	Dim DataMap As Map = Data.Get(Position)
	LoadImage(Parent.GetView(1),DataMap.Get("Image"))
	Dim Banner As Label = Parent.GetView(5)
	LoadImage(Parent.GetView(0),DataMap.Get("Banner"))
	Dim Title=Parent.GetView(2),Size=Parent.GetView(3) As Label
	Title.Text=DataMap.Get("Title")
	Title.SingleLine=True
	Title.Ellipsize="END"
	Banner.Tag=Title.Text
	
	Dim Rated As String=DataMap.Get("Rate")
	Dim Cs As CSBuilder
	Cs.Initialize.Size(12).Append(Rated&" ").Pop _
	.Typeface(Typeface.LoadFromAssets("MaterialIcons.ttf")).Size(10).Append(Chr(0xE838)).Pop.Pop
	Size.Text=Cs.PopAll
	If Position+1 = Data.Size Then
		Parent.Width=356dip
	Else
		Parent.Width=344dip
	End If
	Parent.Height=248dip
	
	Dim MenuLbl As Label = Parent.GetView(6)
	Dim Menu As ACPopupMenu = MenuLbl.Tag
	Menu.GetMenu.Clear
	Menu.AddMenuItem(1&0&Position,"Install",Null)
	Menu.AddMenuItem(2&0&Position,"Add to wishlist",Null)
	If HasAds Then Menu.AddMenuItem(3&0&Position,"Why this ad?",Null)
End Sub

Private Sub Banner_Click
	Dim Lbl As View =Sender
	ToastMessageShow(Lbl.Tag&" Video Clicked!",False)
End Sub



Private Sub CreateBannerViews(Parent As Panel)
	Dim Banner As ImageView
	Banner.Initialize("Banner")
	Parent.AddView(Banner,6dip,0,217dip,122dip)
	
	Dim Img As ImageView
	Img.Initialize("")
	Parent.AddView(Img,6dip,Banner.Height+16dip,40dip,40dip)
	
	Dim Title As Label
	Title.Initialize("")
	Parent.AddView(Title,Img.Left+Img.Width+16dip,Img.Top-2dip,145dip,20dip)
	Title.TextColor=Colors.Black
	Title.TextSize=12
	Title.Gravity=Bit.Or(Gravity.LEFT,Gravity.CENTER_VERTICAL)
	
	Dim Size As Label
	Size.Initialize("")
	Parent.AddView(Size,Title.Left,162dip,50dip,16dip)
	Size.TextColor=Colors.Gray
	Size.TextSize=12
	Size.SingleLine=True
	Size.Ellipsize="END"
	Size.Gravity=Gravity.LEFT
	
	Dim Ripple As Label
	Ripple.Initialize("Ripple")
	Parent.AddView(Ripple,0,0,232dip,182dip)
	Dim Ac As AppCompat
	Ac.SetClickEffect(Ripple,False)
	
	Dim MenuLbl As Label
	MenuLbl.Initialize("")
	Parent.AddView(MenuLbl,214dip,Title.Top,12dip,20dip)
	MenuLbl.TextColor=Colors.DarkGray
	MenuLbl.Text=Chr(0xE5D4)
	MenuLbl.TextSize=16
	MenuLbl.Typeface=Typeface.LoadFromAssets("MaterialIcons.ttf")
	
	Dim MenuClick As Label
	MenuClick.Initialize("MenuClick")
	Parent.AddView(MenuClick,200dip,114dip,36dip,36dip)
	Dim Menu As ACPopupMenu
	Menu.Initialize("Menu",MenuClick)
	MenuClick.Tag=Menu
	MenuLbl.Tag=Menu
	MenuLbl.Gravity=Bit.Or(Gravity.RIGHT,Gravity.CENTER_VERTICAL)
End Sub

Private Sub BindBannerViews (Parent As Panel,Position As Int)
	Dim DataMap As Map = Data.Get(Position)
	LoadImage(Parent.GetView(1),DataMap.Get("Image"))
	LoadImage(Parent.GetView(0),DataMap.Get("Banner"))
	Dim Title=Parent.GetView(2),Size=Parent.GetView(3) As Label
	Title.Text=DataMap.Get("Title")
	Title.SingleLine=True
	Title.Ellipsize="END"
	
	Dim Rated As String=DataMap.Get("Rate")
	Dim Cs As CSBuilder
	Cs.Initialize.Size(12).Append(Rated&" ").Pop _
	.Typeface(Typeface.LoadFromAssets("MaterialIcons.ttf")).Size(10).Append(Chr(0xE838)).Pop.Pop
	Size.Text=Cs.PopAll
	
	If Position+1 = Data.Size Then
		Parent.Width=238dip
		Else
		Parent.Width=226dip
	End If
	Parent.Height=182dip
	
	Dim MenuLbl As Label = Parent.GetView(6)
	Dim Menu As ACPopupMenu = MenuLbl.Tag
	Menu.GetMenu.Clear
	Menu.AddMenuItem(1&0&Position,"Install",Null)
	Menu.AddMenuItem(2&0&Position,"Add to wishlist",Null)
	If HasAds Then Menu.AddMenuItem(3&0&Position,"Why this ad?",Null)
End Sub